
module System.Bkr.BkrWriteExampleConfFile (writeExampleConfFile) where

writeExampleConfFile :: FilePath -> IO ()
writeExampleConfFile path = do
     let s = "# Provide your awsaccesskeyid, awssecretaccesskey and S3 bucket name (the bucket needs to already be created, Bkr will not create a bucket if it doesn't exist).\nawsaccesskeyid: <your awsaccesskeyid>\nawssecretaccesskey: <your awssecretaccesskey>\ns3bucketname: <your s3bucketname>\n\n# Provide the folder to backup and any folders, file types (by file extension) and files you don't want to backup\nfolderstobackup: <comma separated list of folders to backup, for instance: folderstobackup: /Users/username/foldertobackup0, /Users/username/foldertobackup1>\nfolderstoignore: <comma separated list of folders not to backup (leave empty if you don't want to ignore any folders), for instance: folderstoignore: /Users/username/foldertobackup0/donotbackup>\nfileextensionstoignore: <comma separated list of file types not to backup (leave empty if you don't want to ignore any file types), for instance: fileextensionstoignore: .txt, .ppt, pptx>\nfilestoignore: <comma separated list of files not to backup (leave empty if you don't want to ignore any files), for instance: filestoignore: .DS_Store, .localized>\n\n# Use S3 reduced redundancy (yes or no). Please read http://aws.amazon.com/s3/faqs/#What_is_RRS for more information but if the data you are backing up is critical choose no.\nuses3reducedredundancy: no\n\n# File update check algorithm. There are three ways Bkr can determine if a uploaded (backed up) file is the same as a local file or if the local file has been updated. By checksum (safest but slowest), by change date (fastest and safe if you trust you filesystem time stamps) and smart (checksum is guaranteed to be checked every tenth run but the chance of the checksum beeing checked gets 10% higher for every run). Valid choices are: checksum (not recommended unless you need to be sure that the uploaded and local files are the same, will be slow for many and big files), date (recommended if you trust your filesystem timestamps) and smart (the recommended level)\n#fileupdatecheck: checksum\nfileupdatecheck: smart\n#fileupdatecheck: date\n\n# Log file location. Set a location of the log file. Default is $HOME/.bkr.log where $HOME is replaced with your home directory.\nlogfilelocation: $HOME/.bkr.log\n\n# Set maximum size in bytes of the log file. The log file is rotated after the size limit is reached. Default size is 5MB\nlogfilemaximumsize: 5242880\n\n# Valid log levels are: debug (verbose logginig), notify (notifications and errors, the recommended level), critical (only errors)\n#loglevel: debug\nloglevel: notify\n#loglevel: critical"
     writeFile path s